Bash-Snippets/crypt/crypt

185 lines
5.7 KiB
Plaintext
Raw Normal View History

2017-06-27 03:03:40 +02:00
#!/bin/bash
# Author: Alexander Epstein https://github.com/alexanderepstein
2017-07-19 01:31:35 +02:00
currentVersion="1.13.2"
2017-07-06 04:41:31 +02:00
state=""
configuredClient=""
2017-07-03 02:08:08 +02:00
checkOpenSSL()
{
if ! command -v openssl &>/dev/null ;then
echo "Error: to use this tool openssl must be installed" >&2
return 1
else
return 0
fi
}
getConfiguredClient()
{
if command -v curl &>/dev/null ; then
configuredClient="curl"
elif command -v wget &>/dev/null ; then
configuredClient="wget"
elif command -v fetch &>/dev/null ; then
configuredClient="fetch"
else
echo "Error: This tool reqires either curl, wget, or fetch to be installed."
return 1
fi
}
## Allows to call the users configured client without if statements everywhere
httpGet()
{
case "$configuredClient" in
curl) curl -A curl -s "$@";;
wget) wget -qO- "$@";;
fetch) fetch -o "...";;
esac
}
2017-06-27 16:39:27 +02:00
## uses openssl aes 256 cbc encryption to encrypt file salting it with password designated by user
2017-06-27 03:03:40 +02:00
encrypt()
{
2017-07-06 04:41:31 +02:00
echo "Encrypting $1..."
openssl enc -aes-256-cbc -salt -a -in $1 -out $2 || { echo "File not found"; return 1; }
2017-06-27 05:18:18 +02:00
echo "Successfully encrypted"
2017-06-27 03:03:40 +02:00
}
2017-06-27 16:39:27 +02:00
## uses openssl aes 256 cbc decryption to decrypt file
2017-06-27 03:03:40 +02:00
decrypt()
{
2017-07-06 04:41:31 +02:00
echo "Decrypting $1..."
openssl enc -aes-256-cbc -d -a -in $1 -out $2 || { echo "File not found"; return 1; }
2017-06-27 03:03:40 +02:00
echo "Successfully decrypted"
}
2017-06-28 04:40:51 +02:00
update()
{
# Author: Alexander Epstein https://github.com/alexanderepstein
# Update utility version 1.2.0
# To test the tool enter in the defualt values that are in the examples for each variable
repositoryName="Bash-Snippets" #Name of repostiory to be updated ex. Sandman-Lite
githubUserName="alexanderepstein" #username that hosts the repostiory ex. alexanderepstein
nameOfInstallFile="install.sh" # change this if the installer file has a different name be sure to include file extension if there is one
latestVersion=$(httpGet https://api.github.com/repos/$githubUserName/$repositoryName/tags | grep -Eo '"name":.*?[^\\]",'| head -1 | grep -Eo "[0-9.]+" ) #always grabs the tag without the v option
2017-06-28 04:40:51 +02:00
if [[ $currentVersion == "" || $repositoryName == "" || $githubUserName == "" || $nameOfInstallFile == "" ]];then
echo "Error: update utility has not been configured correctly." >&2
exit 1
elif [[ $latestVersion == "" ]];then
echo "Error: no active internet connection" >&2
exit 1
else
if [[ "$latestVersion" != "$currentVersion" ]]; then
echo "Version $latestVersion available"
echo -n "Do you wish to update $repositoryName [Y/n]: "
read -r answer
if [[ "$answer" == "Y" || "$answer" == "y" ]] ;then
cd ~ || { echo 'Update Failed' ; exit 1 ; }
if [[ -d ~/$repositoryName ]]; then rm -r -f $repositoryName || { echo "Permissions Error: try running the update as sudo"; exit 1; } ; fi
2017-06-28 04:40:51 +02:00
git clone "https://github.com/$githubUserName/$repositoryName" || { echo "Couldn't download latest version" ; exit 1; }
cd $repositoryName || { echo 'Update Failed' ; exit 1 ;}
git checkout "v$latestVersion" 2> /dev/null || git checkout "$latestVersion" 2> /dev/null || echo "Couldn't git checkout to stable release, updating to latest commit."
chmod a+x install.sh #this might be necessary in your case but wasnt in mine.
2017-06-30 02:36:20 +02:00
./$nameOfInstallFile "update" || exit 1
2017-06-28 04:40:51 +02:00
cd ..
rm -r -f $repositoryName || { echo "Permissions Error: update succesfull but cannot delete temp files located at ~/$repositoryName delete this directory with sudo"; exit 1; }
2017-06-28 04:40:51 +02:00
else
exit 1
fi
else
echo "$repositoryName is already the latest version"
fi
fi
}
2017-06-29 18:21:28 +02:00
usage()
{
2017-07-08 07:55:55 +02:00
echo "Crypt"
echo "Description: A wrapper around openssl that facilitates encrypting and decrypting files."
2017-06-29 18:21:28 +02:00
echo "Usage: crypt [flag] [inputFile] [outputFile]"
echo " -e Encrypt the inputFile and store it in the outputFile"
echo " -d Decrypt the inputFile and store it in the outputFile"
echo " -u Update Bash-Snippet Tools"
echo " -h Show the help"
echo " -v Get the tool version"
2017-07-08 07:55:55 +02:00
echo "Examples:"
echo " crypt -e mySecretFile.txt myEncryptedFile.jpg (change filetype so default program is incorrect)"
echo " crypt -d myEncryptedFile.jpg thisIsNowDecrypted.txt (change filetype back so now default program is correct)"
2017-06-29 18:21:28 +02:00
}
2017-07-03 02:08:08 +02:00
checkOpenSSL || exit 1
2017-06-29 18:21:28 +02:00
while getopts "huve:d:" opt; do ## alows for using options in bash
2017-06-27 03:03:40 +02:00
case $opt in
2017-06-27 16:39:27 +02:00
e) ## when trying to encrypt run this
2017-07-06 04:41:31 +02:00
if [[ $state != "decrypt" ]];then
state="encrypt"
else
echo "Error: the -d and -e options are mutally exclusive" >&2
exit 1
fi
2017-06-28 04:40:51 +02:00
if [[ $# -ne 3 ]]; then
2017-07-06 04:41:31 +02:00
echo "Option -e needs and only accepts two arguments [file to encrypt] [output file]" >&2
2017-06-27 03:03:40 +02:00
exit 1
fi
2017-07-06 04:41:31 +02:00
2017-06-27 03:03:40 +02:00
;;
\?)
echo "Invalid option: -$OPTARG" >&2
exit 1
;;
2017-06-27 16:39:27 +02:00
d) ## when trying to decrypt run this
2017-07-06 04:41:31 +02:00
if [[ $state != "encrypt" ]];then
state="decrypt"
else
echo "Error: the -e and -d options are mutally exclusive" >&2
exit 1
fi
2017-06-28 04:40:51 +02:00
if [[ $# -ne 3 ]]; then
2017-07-06 04:41:31 +02:00
echo "Option -d needs and only accepts two arguments [file to decrypt] [output file]" >&2
2017-06-27 03:03:40 +02:00
exit 1
fi
;;
2017-06-28 04:40:51 +02:00
u)
getConfiguredClient || exit 1
2017-06-28 04:40:51 +02:00
update
exit 0
;;
2017-06-29 18:21:28 +02:00
h)
usage
exit 0
;;
2017-06-28 04:40:51 +02:00
v)
echo "Version $currentVersion"
exit 0
;;
2017-06-27 16:39:27 +02:00
:) ## will run when no arguments are provided to to e or d options
2017-06-27 03:03:40 +02:00
echo "Option -$OPTARG requires an argument." >&2
exit 1
;;
esac
done
2017-06-28 04:40:51 +02:00
2017-06-29 18:21:28 +02:00
if [[ $# == 0 ]]; then
usage
2017-07-06 04:41:31 +02:00
exit 0
2017-06-29 18:21:28 +02:00
elif [[ $1 == "update" ]];then
getConfiguredClient || exit 1
2017-06-28 04:40:51 +02:00
update
exit 0
2017-06-29 18:21:28 +02:00
elif [[ $1 == "help" ]];then
usage
exit 0
2017-07-06 04:41:31 +02:00
elif [[ $state == "encrypt" ]];then
encrypt $2 $3 || exit 1
exit 0
elif [[ $state == "decrypt" ]];then
decrypt $2 $3 || exit 1
exit 0
2017-06-28 04:40:51 +02:00
fi